#! /usr/bin/perl
#ページファイル出力用サブルーチン定義
sub navOutput {
use Unicode::Normalize;
my $myReg = '[^\x{0340}\x{0341}\x{0343}\x{0344}\x{0374}\x{037E}\x{0387}\x{0958}-\x{095F}\x{09DC}\x{09DD}\x{09DF}\x{0A33}\x{0A36}\x{0A59}-\x{0A5B}\x{0A5E}\x{0B5C}\x{0B5D}\x{0F43}\x{0F4D}\x{0F52}\x{0F57}\x{0F5C}\x{0F69}\x{0F73}\x{0F75}\x{0F76}\x{0F78}\x{0F81}\x{0F93}\x{0F9D}\x{0FA2}\x{0FA7}\x{0FAC}\x{0FB9}\x{1F71}\x{1F73}\x{1F75}\x{1F77}\x{1F79}\x{1F7B}\x{1F7D}\x{1FBB}\x{1FBE}\x{1FC9}\x{1FCB}\x{1FD3}\x{1FDB}\x{1FE3}\x{1FEB}\x{1FEE}\x{1FEF}\x{1FF9}\x{1FFB}\x{1FFD}\x{2000}\x{2001}\x{2126}\x{212A}\x{212B}\x{2329}\x{232A}\x{2ADC}\x{F900}-\x{FA0D}\x{FA10}\x{FA12}\x{FA15}-\x{FA1E}\x{FA20}\x{FA22}\x{FA25}\x{FA26}\x{FA2A}-\x{FA6D}\x{FA70}-\x{FAD9}\x{FB1D}\x{FB1F}\x{FB2A}-\x{FB36}\x{FB38}-\x{FB3C}\x{FB3E}\x{FB40}\x{FB41}\x{FB43}\x{FB44}\x{FB46}-\x{FB4E}\x{1D15E}-\x{1D164}\x{1D1BB}-\x{1D1C0}\x{2F800}-\x{2FA1D}]+';

#テンプレートのパス定義
my $templateNavPath = $FindBin::Bin . "/" . "template_Nav.xhtml";
$templateNavPath = decode('UTF-8', $templateNavPath);
#置換用テンプレートファイルの読み込み
open(TEMPIN,$templateNavPath);
#改行コード削除して1行ごとに配列に収納する処理
my @myTEMPtxts = <TEMPIN>;
my $myTEMPtxts = join("",@myTEMPtxts);
$myTEMPtxts =~ s@\x0D\x0A@\x0D@g;
$myTEMPtxts =~ s@\x0A@\x0D@g;
@myTEMPtxts = split("\x0D",$myTEMPtxts);
close (TEMPIN);
#出力テキスト結合
my $outputText = join("\x{000d}\x{000a}",@myTEMPtxts);
$outputText = decode('UTF-8', $outputText);

my $eachNavImageCount = 0;

our @outputNavTextList;
	foreach $eachNavImageName(@myNavImageList){
		my $nfcConvertedeachNavImageName = $eachNavImageName;
		$nfcConvertedeachNavImageName =~ s/($myReg)/NFC($1)/eg;
		foreach $preRenamefile(sort keys %imageBeforeAfter){
		my $nfcConvertedPreRenamefile = $preRenamefile;
		$nfcConvertedPreRenamefile =~ s/($myReg)/NFC($1)/eg;
		if ($nfcConvertedeachNavImageName eq $nfcConvertedPreRenamefile){
			my $outputNavImageName = $imageBeforeAfter{$preRenamefile};
			my $outputNavTextContents = $myNavTextList[$eachNavImageCount];
			my $navLineText = '<li><a href="xhtml/' . $imagesAndXhtml{$outputNavImageName} . '">' . $outputNavTextContents . '</a></li>';
			push(@outputNavTextList,$navLineText);
		}
	}
	$eachNavImageCount++;
	}

my $outputNavTextMarge = join ("\x{000d}\x{000a}",@outputNavTextList);

#テンプレート内各パラメータの置換
$outputText =~ s@XXXX-NavText-XXXX@$outputNavTextMarge@;

#出力ファイルパスの生成
my $exportNavFilePath = $workItemFolderPath . "/" . "navigation-documents.xhtml";
#論理目次ファイル出力
open(NAVOUT,"> $exportNavFilePath");
	$outputText = encode('UTF-8', $outputText);
	print NAVOUT $outputText;
	close (NAVOUT);
}
1;