#! /usr/bin/perl
use utf8;
#ルートディレクトリに移動
#各対象設定ファイルを読み込んで配列に収納（いらなければ配列から消す）
my @targetConfigFiles = ('.zprofile', '.zshrc', '.bash_profile', '.bashrc');
#各コンフィグ行を収納する配列を定義してpath_helper実行を最初に収納
my @eachConfigDeclaration;
push (@eachConfigDeclaration, 'eval "$(/usr/libexec/path_helper)"');
foreach $targetFile(@targetConfigFiles){
	open(IN, $targetFile);
		my @tagetFileText = <IN>;
		#なんか空行が入るので改行コード統一
		$eachLineTxt = join("",@tagetFileText);
		$eachLineTxt =~ s@\x0D\x0A@\x0D@g;
		$eachLineTxt =~ s@\x0A@\x0D@g;
		@tagetFileText = split("\x0D",$eachLineTxt);
		foreach (@tagetFileText){
			#exportもしくはevalで始まる行のみ抽出して@eachConfigDeclarationに収納
			if ($_ =~ /^(export|eval).+?$/){
				#セミコロンがダブるとエラーになるので行末にあったら消す
				$_ =~ s@^(.+?);$@$1@g;
				#ダブルクォートのエスケープ
				$_ =~ s@"@\"@g;
				push (@eachConfigDeclaration, $_);
			}
		}
	close (IN);
}
#連結して文字列として返す
my $joinedString = join(";",@eachConfigDeclaration);
$joinedString =~ s@"@\"@g;
print $joinedString;
exit;