use utf8;
#Encodeモジュールをインポート
use Encode qw/encode decode/;
use File::Basename qw/basename dirname/;
use File::Path;

my $OriginalImageFolderPath = $ARGV[0];
$OriginalImageFolderPath = decode('UTF-8', $OriginalImageFolderPath);
my $myTitleName = $ARGV[1];
$myTitleName = decode('UTF-8', $myTitleName);
#仮作業ファイル定義（最後にtmpに）
my $epubWorkFolderPath = "/tmp" . "/" . "epubfoldertemplate";

#年月日時刻の生成
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year += 1900;
$mon += 1;
my $dateTimeString = $year . sprintf("%02d",$mon) . sprintf("%02d",$mday) . sprintf("%02d",$hour) . sprintf("%02d",$min) . sprintf("%02d",$sec);

###################epubファイル作成###################
my $epubGenaratePath = dirname $OriginalImageFolderPath;
my $epubPreGenaratePath = dirname $epubWorkFolderPath;

my $epubGenaratecommand = 'cd ' . $epubWorkFolderPath . ';zip -0 -X ../' . $dateTimeString . '.epub' . ' mimetype;zip -r ../' . $dateTimeString . '.epub' . ' * -x mimetype */.DS_Store */*/.DS_Store */*/*/.DS_Store';
system $epubGenaratecommand;


unless ( -f '"' . $epubGenaratePath . "/" . $myTitleName . "/" . '"'){
my $mkdirCommand = 'mkdir ' . '"' . $epubGenaratePath . "/" . $myTitleName . "/" . '"';
system $mkdirCommand;
}

my $epubMoveCommand = 'mv -f ' . $epubPreGenaratePath . "/" . $dateTimeString . '.epub' . " " . '"' . $epubGenaratePath . "/" . $myTitleName . "/" . '"';
print $epubMoveCommand;
system $epubMoveCommand;

#作業用ディレクトリの削除
my $epubWorkFolderDeleteCommand = "rm -r " . $epubWorkFolderPath;
system $epubWorkFolderDeleteCommand;

exit;
