#! /usr/bin/perl
sub imageRenameResize {
	#イメージフォルダの取得
	my $workImageFolderPath = $_[0];
	$workImageFolderPath = decode('UTF-8', $workImageFolderPath);
	#結合済みイメージファイル名の取得
	my $joinedOriginalImageName = $_[1];
	#結合済みイメージファイル名を配列に
	my @originalImageNameList = split(/___{sep}___/, $joinedOriginalImageName);
	#結合済みイメージファイルから画像以外のものを除去
	my @allImageFileList;
	foreach $file(@originalImageNameList){
		unless ($file =~ /^(.*?)\.(jpg|jpeg|png)$/){next;};
		push @allImageFileList, $file;
	}
	
#	#イメージフォルダを開く
#	opendir(DIRHANDLE, "$workImageFolderPath");
#	my @allImageFileList;
#	#イメージファイルのみをリストとして取得
#	foreach $file(readdir(DIRHANDLE)){
#		unless ($file =~ /^(.*?)\.(jpg|jpeg|png)$/){next;};
#		push @allImageFileList, $file;
#	}
	#####フォルダ内ファイルのリネーム#####
	closedir(DIRHANDLE);
	our %imageBeforeAfter;
	my $fileNum = 0;
	chdir $workImageFolderPath;
	foreach (@allImageFileList){
		if ($fileNum == 0){
			if (/\.(jpg|jpeg)$/i){
				rename $_,"cover.jpg";
				$imageBeforeAfter{$_} = "cover.jpg";
			} elsif (/\.png$/i){
				rename $_,"cover.png";
				$imageBeforeAfter{$_} = "cover.png";
			}
			$fileNum++;
		} else {
			if (/\.(jpg|jpeg)$/i){
				our $renamedFile = "i-" . sprintf("%04d", $fileNum) . ".jpg";
			} elsif (/\.png$/i){
				our $renamedFile = "i-" . sprintf("%04d", $fileNum) . ".png";
			}
			rename $_,$renamedFile;
			$imageBeforeAfter{$_} = $renamedFile;
			$fileNum++;
		}
	}
	
	#####イメージリサイズ処理#####
	if ($myImageConvertExecution eq "0"){
	foreach (sort keys %imageBeforeAfter){
		my $resizeImageName = $imageBeforeAfter{$_};
		my $resizeImagePath = $workImageFolderPath . "/" . $resizeImageName;
		if ($resizeImageName =~ /\.(jpg|jpeg)$/i){
			our $mogrifyCommand = "mogrify" . " -geometry " . $imageLongSideLength . "x" . $imageLongSideLength . " " . "-strip -quality " . $jpgImageQuality . " " . $resizeImagePath;
		} elsif ($resizeImageName =~ /\.png$/i){
			if ($pngImageQuality eq "notdecleasecolor"){
					our $mogrifyCommand = "mogrify" . " -geometry " . $imageLongSideLength . "x" . $imageLongSideLength . " " . "-depth 8 -strip -quality 95 " . $resizeImagePath;
			} else {
				our $mogrifyCommand = "mogrify" . " -geometry " . $imageLongSideLength . "x" . $imageLongSideLength . " " . "-depth 8 " . "-colors " . $pngImageQuality . " -strip -quality 95 " . $resizeImagePath;
			}
		}
		
		print $mogrifyCommand . "\n";
		
	system $mogrifyCommand;
	}
	}
	return %imageBeforeAfter;
}
1;