#! /usr/bin/perl
#ページファイル出力用サブルーチン定義
sub opfFileOutput {
our $myTitleName = $_[0];
our $myTitleNameKana = $_[1];
our $totalCreatorBlock = $_[2];
our $totalPublisherBlock = $_[3];
our $uuidString = $_[4];
our $dateTime = $_[5];
our $imageWidth = $_[6];
our $imageHeight = $_[7];
our $totalManifestImageBlock = $_[8];
our $totalManifestXhtmlBlock = $_[9];
our $totalSpineBlock = $_[10];
our $itemFolderPath = $_[11];
our $myPageDirection = $_[12];

#テンプレートのパス定義
my $templateOpfPath = $FindBin::Bin . "/" . "templatestandard.opf";
$templateOpfPath = decode('UTF-8', $templateOpfPath);
#置換用テンプレートファイルの読み込み
open(TEMPIN,$templateOpfPath);
#改行コード削除して1行ごとに配列に収納する処理
my @myTEMPtxts = <TEMPIN>;
my $myTEMPtxts = join("",@myTEMPtxts);
$myTEMPtxts =~ s@\x0D\x0A@\x0D@g;
$myTEMPtxts =~ s@\x0A@\x0D@g;
@myTEMPtxts = split("\x0D",$myTEMPtxts);
close (TEMPIN);
#出力テキスト結合
my $outputText = join("\x{000d}\x{000a}",@myTEMPtxts);
$outputText = decode('UTF-8', $outputText);
#テンプレート内各パラメータの置換
$outputText =~ s@XXXX-Title-XXXX@$myTitleName@;
$outputText =~ s@XXXX-TitleKana-XXXX@$myTitleNameKana@;
$outputText =~ s@XXXX-Creator-XXXX@$totalCreatorBlock@;
$outputText =~ s@XXXX-Publisher-XXXX@$totalPublisherBlock@;
$outputText =~ s@XXXX-UUID-XXXX@$uuidString@;
$outputText =~ s@XXXX-DateTime-XXXX@$dateTime@;
$outputText =~ s@XXXX-ImageWidth-XXXX@$imageWidth@g;
$outputText =~ s@XXXX-ImageHeight-XXXX@$imageHeight@g;
$outputText =~ s@XXXX-ManifestImage-XXXX@$totalManifestImageBlock@;
$outputText =~ s@XXXX-ManifestXhtml-XXXX@$totalManifestXhtmlBlock@;
$outputText =~ s@XXXX-Spine-XXXX@$totalSpineBlock@;
	if ($myPageSpread eq "doublepage"){
		$outputText =~ s@XXXX-Spread-XXXX@landscape@;
	} elsif ($myPageSpread eq "singlepage"){
		$outputText =~ s@XXXX-Spread-XXXX@none@;
	}
	if ($myPageDirection eq "rtl"){
		$outputText =~ s@XXXX-WrithingMode-XXXX@vertical-rl@;
	} elsif ($myPageDirection eq "ltr"){
		$outputText =~ s@XXXX-WrithingMode-XXXX@horizontal-lr@;
	}

#出力ファイルパスの生成
my $exportFilePath = $itemFolderPath . "/" . "standard.opf";
#opfファイル出力
open(OPFOUT,"> $exportFilePath");
	$outputText = encode('UTF-8', $outputText);
	print OPFOUT $outputText;
	close (OPFOUT);
}
1;