#! /usr/bin/perl
#ページファイル出力用サブルーチン定義
sub xhtmlOutput {
our $imageFileName = $_[0];
our $xhtmlFileName = $_[1];
our $workXhtmlFolderPath = $_[2];
our $imageWidth= $_[3];
our $imageHeight = $_[4];
my $myTitleName = $_[5];
#各テンプレートのパス定義
my $templateCoverPagePath = $FindBin::Bin . "/" . "template_CoverPage.xhtml";
$templateCoverPagePath = decode('UTF-8', $templateCoverPagePath);
my $templateNormalPagePath = $FindBin::Bin . "/" . "template_NormalPage.xhtml";
$templateNormalPagePath = decode('UTF-8', $templateNormalPagePath);
#使うテンプレートファイルの決定
if ($imageFileName eq "cover.jpg"){
	$templateFilePath = $templateCoverPagePath;
} else {
	$templateFilePath = $templateNormalPagePath;
}
#置換用テンプレートファイルの読み込み
open(TEMPIN,$templateFilePath);
#改行コード削除して1行ごとに配列に収納する処理
my @myTEMPtxts = <TEMPIN>;
my $myTEMPtxts = join("",@myTEMPtxts);
$myTEMPtxts =~ s@\x0D\x0A@\x0D@g;
$myTEMPtxts =~ s@\x0A@\x0D@g;
@myTEMPtxts = split("\x0D",$myTEMPtxts);
close (TEMPIN);
#出力テキスト結合
my $outputText = join("\x{000d}\x{000a}",@myTEMPtxts);
#$outputText = decode('UTF-8', $outputText);
#テンプレート内各パラメータの置換
$outputText =~ s@■■■ImageWidth■■■@$imageWidth@ig;
$outputText =~ s@■■■ImageHeight■■■@$imageHeight@ig;
$outputText =~ s@■■■Filename■■■@$imageFileName@ig;
$outputText =~ s@■■■Title■■■@$myTitleName@ig;
#出力ファイルパスの生成
my $exportFilePath = $workXhtmlFolderPath . "/" . $xhtmlFileName;
#xhtmlファイル出力
open(XHTMLOUT,"> $exportFilePath");
	$outputText = encode('UTF-8', $outputText);
	print XHTMLOUT $outputText;
	close (XHTMLOUT);
}
1;