#! /usr/bin/perl
use utf8;
#Encodeモジュールをインポート
use Encode qw/encode decode/;

#コンフィグファイルのパス読み込み
my $myConfigFilePath = $ARGV[0];
$myConfigFilePath = decode('UTF-8', $myConfigFilePath);

#どのパラメータを読み込むかの分岐
our $whichParametaRead = $ARGV[1];
$whichParametaRead = decode('UTF-8', $whichParametaRead);

#コンフィグファイルの内容読み込み
open(CONFIGIN,$myConfigFilePath);
my @myConfigTxts = <CONFIGIN>;

if ($whichParametaRead eq "imageconvertsize:"){
	our $outputConfigValue = &parametaRead(0);
	$outputConfigValue =~ s@^imageconvertsize:@@;
} elsif ($whichParametaRead eq "jpegimagequality:"){
	our $outputConfigValue = &parametaRead(1);
	$outputConfigValue =~ s@^jpegimagequality:@@;
} elsif ($whichParametaRead eq "pngdecleasecolor:"){
	our $outputConfigValue = &parametaRead(2);
	$outputConfigValue =~ s@^pngdecleasecolor:@@;
} elsif ($whichParametaRead eq "pngimagequality:"){
	our $outputConfigValue = &parametaRead(3);
	$outputConfigValue =~ s@^pngimagequality:@@;
} elsif ($whichParametaRead eq "notConvertImageMagick:"){
	our $outputConfigValue = &parametaRead(4);
	$outputConfigValue =~ s@^notConvertImageMagick:@@;
} elsif ($whichParametaRead eq "imagemagickPathCustomSelect:"){
	our $outputConfigValue = &parametaRead(5);
	$outputConfigValue =~ s@^imagemagickPathCustomSelect:@@;
} elsif ($whichParametaRead eq "customSpecifiedImagemagickPath:"){
	our $outputConfigValue = &parametaRead(6);
	$outputConfigValue =~ s@^customSpecifiedImagemagickPath:@@;
} 

close (CONFIGIN);

encode('UTF-8', $outputConfigValue);
print $outputConfigValue;

sub parametaRead {
	my $ConfigLineNum = $_[0];
	$returnValue = $myConfigTxts[$ConfigLineNum];
	$returnValue =~ s@^$whichParametaRead@@;
	$returnValue =~ chomp($returnValue);
	decode('UTF-8', $returnValue);
	return $returnValue;
}

exit;
