#! /usr/bin/perl
use utf8;
#Encodeモジュールをインポート
use Encode qw/encode decode/;
use File::Basename qw/basename dirname/;
use FindBin;

#コンフィグファイルのパス読み込み
my $myConfigFilePath = $ARGV[0];
$myConfigFilePath = decode('UTF-8', $myConfigFilePath);
#書き込むパラメータ種別の読み込み
our $myWriteParameterType = $ARGV[1];
$myWriteParameterType = decode('UTF-8', $myWriteParameterType);
#書き込むパラメータ値の読み込み
our $myParameterString = $ARGV[2];
$myParameterString = decode('UTF-8', $myParameterString);
#書き換え
open(CONFIGIN,$myConfigFilePath);
our @myConfigTxts = <CONFIGIN>;
foreach(@myConfigTxts){
	decode('UTF-8', $_);
	s@\n@@;
}
if ($myWriteParameterType eq "imageconvertsize:"){
	$myConfigTxts[0] = $myWriteParameterType . $myParameterString;
} elsif ($myWriteParameterType eq "jpegimagequality:"){
	$myConfigTxts[1] = $myWriteParameterType . $myParameterString;
} elsif ($myWriteParameterType eq "pngdecleasecolor:"){
	$myConfigTxts[2] = $myWriteParameterType . $myParameterString;
} elsif ($myWriteParameterType eq "pngimagequality:"){
	$myConfigTxts[3] = $myWriteParameterType . $myParameterString;
} elsif ($myWriteParameterType eq "notConvertImageMagick:"){
	$myConfigTxts[4] = $myWriteParameterType . $myParameterString;
} elsif ($myWriteParameterType eq "imagemagickPathCustomSelect:"){
	$myConfigTxts[5] = $myWriteParameterType . $myParameterString;
} elsif ($myWriteParameterType eq "customSpecifiedImagemagickPath:"){
	$myConfigTxts[6] = $myWriteParameterType . $myParameterString;
}
close (CONFIGIN);
my $finalOutputConfigTxt = join("\n",@myConfigTxts);

#コンフィグファイルに出力
open(CONFIGOUT,"> $myConfigFilePath");
	$finalOutputConfigTxt = encode('UTF-8', $finalOutputConfigTxt);
	print CONFIGOUT $finalOutputConfigTxt;
	close (CONFIGOUT);

exit;
